local Spot = GetModConfigData("Spot")
PrefabFiles = {
	"qianhu",
	"qianhuhamlet",
	"tankcamp",
	"ranger",
	"ranger_bullet",
	"yuli",
	"yulihamlet",
	"gunfire",
	"gunblood",
	"junliang",
	"empty",
	"spider_haojie",
	"spider_xianfeng",
	"red_lightning",
	"nuko",
	"nukotower",
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/qianhu.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/qianhu.xml" ),

    Asset( "IMAGE", "bigportraits/qianhu.tex" ),
    Asset( "ATLAS", "bigportraits/qianhu.xml" ),
	
	Asset( "IMAGE", "images/map_icons/qianhu.tex" ),
	Asset( "ATLAS", "images/map_icons/qianhu.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_qianhu.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_qianhu.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_ghost_qianhu.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_ghost_qianhu.xml" ),
	
	 Asset( "IMAGE", "images/saveslot_portraits/yuli.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/yuli.xml" ),

    Asset( "IMAGE", "bigportraits/yuli.tex" ),
    Asset( "ATLAS", "bigportraits/yuli.xml" ),
	
	Asset( "IMAGE", "images/map_icons/yuli.tex" ),
	Asset( "ATLAS", "images/map_icons/yuli.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_yuli.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_yuli.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_ghost_yuli.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_ghost_yuli.xml" ),
	
	 Asset( "IMAGE", "minimap/tankcamp.tex" ),
     Asset( "ATLAS", "minimap/tankcamp.xml" ),
	 Asset( "IMAGE", "minimap/nukotower.tex" ),
     Asset( "ATLAS", "minimap/nukotower.xml" ),
     Asset("ATLAS", "images/inventoryimages/ui_chest_3x4.xml"),
	 Asset("ATLAS", "images/inventoryimages/tankcamp.xml"),
	Asset("SOUNDPACKAGE", "sound/nuko.fev"),
	Asset("SOUND", "sound/nuko.fsb"),
}

local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local TECH = GLOBAL.TECH

local TUNING = GLOBAL.TUNING
local Player = GLOBAL.ThePlayer
local TheNet = GLOBAL.TheNet
local IsServer = GLOBAL.TheNet:GetIsServer()
local TheInput = GLOBAL.TheInput
local TimeEvent = GLOBAL.TimeEvent
local FRAMES = GLOBAL.FRAMES
local EQUIPSLOTS = GLOBAL.EQUIPSLOTS
local EventHandler = GLOBAL.EventHandler
local SpawnPrefab = GLOBAL.SpawnPrefab
local State = GLOBAL.State
local DEGREES = GLOBAL.DEGREES
local Vector3 = GLOBAL.Vector3
local ACTIONS = GLOBAL.ACTIONS
local FOODTYPE = GLOBAL.FOODTYPE
local PLAYERSTUNLOCK = GLOBAL.PLAYERSTUNLOCK
local GetTime = GLOBAL.GetTime
local HUMAN_MEAT_ENABLED = GLOBAL.HUMAN_MEAT_ENABLED
local TheSim = GLOBAL.TheSim

local ACTIONS = GLOBAL.ACTIONS
local ActionHandler = GLOBAL.ActionHandler
if GLOBAL.TheSim.RAILGetPlatform and GLOBAL.TheSim:RAILGetPlatform() == "TGP" then
      for _, mod in ipairs(GLOBAL.ModManager.mods) do 
           if mod and mod.modinfo and mod.modinfo.id  == "少女终末旅行"  then
                GLOBAL.KnownModIndex:Disable("少女终末旅行")
          end
      end
	print("########################################################")
	print("同胞们，听我说:")
	print("时间不多了，摆在你面前的是这个种族和文明在战火中所存留下来的一切。")	
	print("还有那些在TGP上被腐化的同胞。")
	print("我们的族人曾掌控饥荒，我们的前途曾充满荣光。")
	print("但是在傲慢与分裂之下，我们辜负了神圣的职责，走向了灭亡。")
	print("腾讯，似乎是团结我们的纽带，却最终铸成了这场分裂。它所带来的希望不过是个谎言。")
	print("如今，我们必须抛弃这一谎言，还有我们所有的偏见与傲慢，让他们成为历史。")
	print("因为我们正为了同样的信念而战，那就是，坚信我们饥友绝不会就此消亡！")
	print("坚信我们饥友能够秉承同样的信念团结一致，坚信我们饥友能够创造一个更加伟大而强盛的文明。")
	print("在战斗中信任彼此，凝聚意志，让这最后一战永垂不朽！")
	print("En Trao Steam!En Trao Gabe!En Trao Don'tStarve !")
	print("########################################################")
     GLOBAL.Shutdown()
end


-- The character select screen lines
STRINGS.CHARACTER_TITLES.qianhu = "宇宙最强工程师"
STRINGS.CHARACTER_NAMES.qianhu = "千户"
STRINGS.CHARACTER_DESCRIPTIONS.qianhu = "*是一位机车手\n*比她的尤莉聪明多了\n*狠喜欢她的朋友尤莉"
STRINGS.CHARACTER_QUOTES.qianhu = "\"脑袋不好使的家伙就该多动手\""

STRINGS.CHARACTER_TITLES.yuli = "雷诺的游骑兵"
STRINGS.CHARACTER_NAMES.yuli = "尤莉"
STRINGS.CHARACTER_DESCRIPTIONS.yuli = "*擅长射击\n*巨能吃\n*超喜欢她的朋友千酱"
STRINGS.CHARACTER_QUOTES.yuli = "\"记忆这种东西，妨碍我活着\""

GLOBAL.STRINGS.NAMES.TANKCAMP = "机车营地"
STRINGS.RECIPE_DESC.TANKCAMP = "用一辆旧车做营地如何？"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.TANKCAMP = "我们的家~"


        local tankcamp = 
		AddRecipe("tankcamp", {Ingredient("transistor", 10), Ingredient("rope", 5), Ingredient("boards", 10)}, 
		RECIPETABS.TOWN, TECH.NONE, "tankcamp_placer", nil, nil, nil, "tankcamp_builder", "images/inventoryimages/tankcamp.xml", "tankcamp.tex" )

        local eightxten = (GetModConfigData("eightxten")=="8x10")
        GLOBAL.yep = (GetModConfigData("workit")=="yep")
		if (GetModConfigData("smartdidui")=="true") then 
			GLOBAL.TUNING.SMARTDIDUI = true 
		else
			GLOBAL.TUNING.SMARTDIDUI = false
		end
		
--------------------------------------

if eightxten then

_G = GLOBAL
local params={} 
params.tankcamp =
{
    widget =
    {
        slotpos = {},
        --animbank = "ui_chester_shadow_3x4",
        --animbuild = "ui_chester_shadow_3x4",
        pos = _G.Vector3(0, 220, 0),
        side_align_tip = 160,
    },
    type = "chest",
}

for y = 6.5, -0.5, -1 do
    for x = 0, 9 do
        table.insert(params.tankcamp.widget.slotpos, _G.Vector3(75 * x - 75 * 12 + 75, 75 * y - 75 * 6 + 75, 0))
    end
end

local containers = _G.require "containers"
containers.MAXITEMSLOTS = math.max(containers.MAXITEMSLOTS, params.tankcamp.widget.slotpos ~= nil and #params.tankcamp.widget.slotpos or 0)
local old_widgetsetup = containers.widgetsetup
function containers.widgetsetup(container, prefab, data)
        local pref = prefab or container.inst.prefab
        if pref == "tankcamp" then
                local t = params[pref]
                if t ~= nil then
                        for k, v in pairs(t) do
                                container[k] = v
                        end
                        container:SetNumSlots(container.widget.slotpos ~= nil and #container.widget.slotpos or 0)
                end
        else
                return old_widgetsetup(container, prefab)
    end
end

        else

_G = GLOBAL
local params={} 
params.tankcamp =
{
    widget =
    {
        slotpos = {},
        --animbank = "ui_chester_shadow_3x4",
        --animbuild = "ui_chester_shadow_3x4",
        pos = _G.Vector3(0, 220, 0),
        side_align_tip = 160,
    },
    type = "chest",
}

for y = 3.5, -0.5, -1 do
    for x = 0, 15 do
        table.insert(params.tankcamp.widget.slotpos, _G.Vector3(75 * x - 75 * 16 + 75, 75 * y - 75 * 3 + 75, 0))
    end
end

local containers = _G.require "containers"
containers.MAXITEMSLOTS = math.max(containers.MAXITEMSLOTS, params.tankcamp.widget.slotpos ~= nil and #params.tankcamp.widget.slotpos or 0)
local old_widgetsetup = containers.widgetsetup
function containers.widgetsetup(container, prefab, data)
        local pref = prefab or container.inst.prefab
        if pref == "tankcamp" then
                local t = params[pref]
                if t ~= nil then
                        for k, v in pairs(t) do
                                container[k] = v
                        end
                        container:SetNumSlots(container.widget.slotpos ~= nil and #container.widget.slotpos or 0)
                end
        else
                return old_widgetsetup(container, prefab)
        end
    end
end

-- Custom speech strings
STRINGS.CHARACTERS.QIANHU = require "speech_qianhu"
STRINGS.CHARACTERS.YULI= require "speech_yuli"
AddRecipe("qianhuhamlet", 
{Ingredient("goldnugget", 3), Ingredient("rope", 2), Ingredient("beefalowool", 5)}, 
RECIPETABS.WAR, TECH.NONE, nil, nil, nil, nil, "qianhuhamlet_builder", "images/inventoryimages/qianhuhamlet.xml", "qianhuhamlet.tex" )
AddRecipe("yulihamlet", 
{Ingredient("goldnugget", 3), Ingredient("rope", 2), Ingredient("beefalowool", 5)}, 
RECIPETABS.WAR, TECH.NONE, nil, nil, nil, nil, "yulihamlet_builder", "images/inventoryimages/yulihamlet.xml", "yulihamlet.tex" )
AddRecipe("junliang", 
{Ingredient("cookedmeat", 1), Ingredient("carrot_cooked", 2), Ingredient("papyrus", 1)}, 
RECIPETABS.FARM, TECH.NONE, nil, nil, nil, nil, "junliang_builder", "images/inventoryimages/junliang.xml", "junliang.tex" )

if TUNING.SMARTDIDUI  then 
AddRecipe("zg_weapon_shotgun", 
{Ingredient("goldnugget", 3), Ingredient("rope", 2), Ingredient("nitre", 5)}, 
RECIPETABS.WAR, TECH.NONE, nil, nil, nil, nil, "ranger_builder", "images/zg_we_zhongzheng.xml", "zg_we_zhongzheng.tex" )
STRINGS.RECIPE_DESC.ZG_WEAPON_SHOTGUN = "游骑兵....在智能敌对里的版本...."
AddRecipe("empty", 
{Ingredient("goldnugget", 2), Ingredient("nitre", 3)}, 
RECIPETABS.WAR, TECH.NONE, nil, nil, nil, nil, "ranger_bullet_builder", "images/zg_it_bulletmusket.xml", "zg_it_bulletmusket.tex" )
STRINGS.NAMES.EMPTY = "中正式步枪子弹(15发/盒)"
STRINGS.RECIPE_DESC.EMPTY = "尤莉的黑科技弹药"
else 
AddRecipe("ranger", 
{Ingredient("goldnugget", 3), Ingredient("rope", 2), Ingredient("nitre", 5)}, 
RECIPETABS.WAR, TECH.NONE, nil, nil, nil, nil, "ranger_builder", "images/inventoryimages/ranger.xml", "ranger.tex" )
AddRecipe("ranger_bullet", 
{Ingredient("goldnugget", 2), Ingredient("nitre", 3)}, 
RECIPETABS.WAR, TECH.NONE, nil, nil, nil, 5, "ranger_bullet_builder", "images/inventoryimages/ranger_bullet.xml", "ranger_bullet.tex" )
end 

-- The character's name as appears in-game 
STRINGS.NAMES.QIANHU = "千户"
STRINGS.NAMES.YULI = "尤莉"
STRINGS.NAMES.SPIDER_HAOJIE = "先史遗产·浩劫"
STRINGS.NAMES.SPIDER_XIANFENG = "先史遗产·先锋"
STRINGS.NAMES.NUKO = "花泽香肠"
STRINGS.NAMES.NUKOTOWER = "花泽神柱"
-- The default responses of examining the character
STRINGS.CHARACTERS.GENERIC.DESCRIBE.QIANHU = 
{
	GENERIC = "千酱！",
	ATTACKER = "千酱！",
	MURDERER = "千酱！",
	REVIVER = "千酱！",
	GHOST = "千酱！千酱！",
}
STRINGS.CHARACTERS.GENERIC.DESCRIBE.YULI = 
{
	GENERIC = "尤~",
	ATTACKER = "尤~",
	MURDERER = "尤~",
	REVIVER = "尤~",
	GHOST = "尤~尤~",
}

GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})
AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.EAT, function(inst, action)
            if inst.sg:HasStateTag("busy") then
                return
            end
            local obj = action.target or action.invobject
            if obj == nil or obj.components.edible == nil then
                return
            elseif not inst.components.eater:PrefersToEat(obj) then
                inst:PushEvent("wonteatfood", { food = obj })
                return
            end
			if inst.prefab == "yuli" then --改人物
            return "quickeat"
			else
			    return (inst:HasTag("beaver") and "beavereat")
                or (obj.components.edible.foodtype == FOODTYPE.MEAT and "eat")
                or "quickeat"
			end
    end
  )
)
AddStategraphActionHandler("wilson_client", ActionHandler(ACTIONS.EAT, function(inst, action)
            if inst.sg:HasStateTag("busy") or inst:HasTag("busy") then
                return
            end
            local obj = action.target or action.invobject
            if obj == nil then
                return
            end
            for k, v in pairs(FOODTYPE) do
                if obj:HasTag("edible_"..v) then
					if inst.prefab == "yuli" then  --改人物
                        return "quickeat"
					else
                    return (inst:HasTag("beaver") and "beavereat")
                        or (v == FOODTYPE.MEAT and "eat")
                        or "quickeat"
					end
                end
            end
        end)
)



AddStategraphState("wilson", require "stategraphs/sgattack")
AddStategraphState("wilson_client", require "stategraphs/sgattack_client")
--AddStategraphState("SGspider", require "sg/SGhaojie")
AddMinimapAtlas("images/map_icons/qianhu.xml")
AddMinimapAtlas("images/map_icons/yuli.xml")
AddMinimapAtlas("minimap/tankcamp.xml")
AddMinimapAtlas("minimap/nukotower.xml")
-- Add mod character to mod character list. Also specify a gender. Possible genders are MALE, FEMALE, ROBOT, NEUTRAL, and PLURAL.
AddModCharacter("qianhu", "FEMALE")
AddModCharacter("yuli", "FEMALE")
require "worldtower"

AddPrefabPostInit("world",function(inst)
	if TheNet:GetIsServer() then
		inst:AddComponent("towersp")
	end
end)
