local assets =
{
    Asset("ANIM", "anim/nukotower.zip"),
}

local prefabs =
{
    "marble",
  
}


SetSharedLootTable( 'nukotower',
{
    {'marble', 1.00},
	{'marble', 1.00},
	{'marble', 1.00},
	{'marble', 1.00},
	{'marble', 1.00},
	{'marble', 1.00},
    {'marble', 1.00},
    {'marble', 0.33},
})

local function onworked(inst, worker, workleft)

    if workleft <= 0 then
        local pos = inst:GetPosition()
		SpawnPrefab("rock_break_fx").Transform:SetPosition(pos:Get())
        inst.components.lootdropper:DropLoot(pos)
        inst:Remove()
    else

        inst.AnimState:PlayAnimation(
            (workleft < TUNING.MARBLEPILLAR_MINE / 3 and "idle_low") or
            (workleft < TUNING.MARBLEPILLAR_MINE * 2 / 3 and "idle_med") or
            "idle_full"
        )
	end

end

local function OnVacate(inst)
    SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
end


local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddMiniMapEntity()
    inst.entity:AddNetwork()

    MakeObstaclePhysics(inst, 1)
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon("nukotower.tex")
	

    inst.AnimState:SetBank("nukotower")
    inst.AnimState:SetBuild("nukotower")
    inst.AnimState:PlayAnimation("idle_full")
	inst.Transform:SetScale(1.2,1.2,1.2)
	inst:AddTag("nukotower")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("lootdropper")
	inst.components.lootdropper:SetChanceLootTable('nukotower')

    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("这是···千酱？？？！！")
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.MINE)
    inst.components.workable:SetOnWorkCallback(onworked)
	
    inst:AddComponent("childspawner")
    inst.components.childspawner.childname = "nuko"
    inst.components.childspawner:SetRegenPeriod(TUNING.TOTAL_DAY_TIME *4 )
    inst.components.childspawner:SetSpawnPeriod(TUNING.TOTAL_DAY_TIME / 60)
    inst.components.childspawner:SetMaxChildren(2)
    inst.components.childspawner:StartSpawning()

    MakeHauntableWork(inst)
    MakeSnowCovered(inst)

    return inst
end

return Prefab("nukotower", fn, assets, prefabs)